/*
 * Created on 07.05.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package de.inso_gmbh.swt.widgets;

import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;

/**
 * @author Bernd Lachner, InSo GmbH
 *
 * Widget for viewing an image.
 */
public class ImageViewer extends Canvas implements PaintListener
{
	protected Image m_oImage = null;
	
	/**
	 * Constructor.
	 * 
	 * @param oParent The widgets parent composite.
	 * @param iStyle The style of the widget. See styles of Canvas class.
	 */
	public ImageViewer(Composite oParent, int iStyle)
	{
		super(oParent, iStyle);
		addPaintListener(this);
	}
	
	/**
	 * Loads an image and shows it if possible.
	 * 
	 * @param sImageName Filename of the image to load.
	 */
	public void loadImage(String sImageName)
	{
		try
		{
			ImageLoader oImageLoader = new ImageLoader();
			this.m_oImage = new Image(this.getDisplay(), oImageLoader.load(sImageName)[0]);
		}
		catch (Exception oException)
		{
			this.m_oImage = null;
		}
		finally
		{
			this.redraw();
		}
	}

	/**
	 * Gets the image actually loaded or null if none is loaded.
	 * 
	 * @return Acual viewed image.
	 */	
	public Image getImage()
	{
		return this.m_oImage;
	}
	
	/**
	 * Clears the viewer.
	 *
	 */
	public void clearImage()
	{
		this.m_oImage = null;
		this.redraw();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.PaintListener#paintControl(org.eclipse.swt.events.PaintEvent)
	 */
	public void paintControl(PaintEvent oPaintEvent) 
	{
		if (this.m_oImage != null)
		{
			oPaintEvent.gc.drawImage(this.m_oImage, 0, 0);
		}
	}
}
